//---------------------------------------------------------------------------
#define INITGUID       // This critical line causes the GUIDS to actually be
                       // defined (instead of just declared) in this file.
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be perfomring new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you


//---------------------------------------------------------------------------
#include "3DCoFail.h"          // Not sure what this does, but examples include it

#include "ValShdrFac.h"        // Value Shader Factroy definition
#include "ValShdrObj.h"
#include "ValShdr.h"

//---------------------------------------------------------------------------
int global_count_Obj  = 0;
int global_count_Lock = 0;

// This next section (plus the putting STDAPI_FIX after all the function
// declarations which use STDAPI is needed because Microsoft thinks everyone
// is using Visual C++ for Win32 programming which doesn't support export.
// The Borland compiler does.
// Note that the function definitions don't need this fix.
#ifdef __BORLANDC__
#define STDAPI_FIX __export
#else
#define STDAPI_FIX
#endif

// Note that DllEntryPoint is not exported (apparently RDS doesn't use it), but BCB requires the
// function, so the body must be left in.
STDAPI STDAPI_FIX DllCanUnloadNow();
STDAPI STDAPI_FIX DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID FAR* ppv);
STDAPI STDAPI_FIX DllInitRDCom(IShUtilities* shellUtilities);

//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
   return 1;
}
//---------------------------------------------------------------------------


// ****** Not sure what this function does (it is related to that mysterious
// ****** 'fail' library), but examples include it.
STDAPI DllInitRDCom(IShUtilities* shellUtilities)
{
	InitCoFailure(shellUtilities);
	return S_OK;
}

// ****** The all-important COM-defined function that gets a class factory
// ****** for the actual shader object
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID FAR* ppv)
{
   if (!IsEqualCLSID(rclsid, CLSID_EDPValShader))
       return ResultFromScode(E_FAIL);

   //Check that we can provide the interface
   if (!IsEqualIID(riid, IID_IUnknown) && !IsEqualIID(riid, IID_IClassFactory))
       return ResultFromScode(E_NOINTERFACE);

   //Return our IClassFactory for the correct Shader objects
   *ppv=(LPVOID) new ValShaderFactory();

   if (*ppv == NULL)
       return ResultFromScode(E_OUTOFMEMORY);

   //AddRef the object through any interface we return
   ((LPUNKNOWN)*ppv)->AddRef();

   return NOERROR;
}


// ****** Another COM-defined function which is called to determine if the
// ****** DLL can be unloaded. Resolved by examining the DLL global variables
// ****** which count objects and locks
STDAPI DllCanUnloadNow()
{
   return ResultFromScode(
       global_count_Obj == 0 && global_count_Lock == 0 ? S_OK : S_FALSE);
}

// ****** Note that the DLL does not have a DllRegisterServer or
// ****** DllUnregisterServer function because RDS extensions do not
// ****** use the registry

