//---------------------------------------------------------------------------
#ifndef ValShdrObjH
#define ValShdrObjH
//---------------------------------------------------------------------------
#include "I3dexsha_bcb.h"      // Shader interface definition

// My GUIDS
DEFINE_GUID(CLSID_EDPValShader, 0xD64CBB10, 0x24CF,
   0x11D2, 0x80, 0xDF, 0x20, 0xB6, 0xA4, 0x00, 0x00, 0x00);

DEFINE_GUID(IID_IEDPValShader, 0x704749A0, 0x24DE,
   0x11D2, 0x80, 0xDF, 0x20, 0xB6, 0xA4, 0x00, 0x00, 0x00);

// Data structure for exchange with the Shell
struct EDPValShaderPublicData
{
   short sliderValue;  // Slider value
};

// Shader odject definition
#undef INTERFACE
#define INTERFACE CheckerShader
class EDPValShader : public I3DExShader
{
 public :
   EDPValShader();
   ~EDPValShader();

   // IUnknown methods
   STDMETHODIMP QueryInterface(THIS_ REFIID riid, LPVOID FAR* ppvObj);
   STDMETHODIMP_(ULONG) AddRef(THIS);
   STDMETHODIMP_(ULONG) Release(THIS);
  
   // I3DExtension methods
   STDMETHODIMP_(I3DExtension*) Clone(THIS);
   STDMETHODIMP ShellUtilitiesInit(THIS_ IShUtilities* shellUtilities);

   // I3DExDataExchanger methods
   STDMETHODIMP_(ExtensionDataMap*) GetExtensionDataMap(THIS);
   STDMETHODIMP_(void*) GetExtensionDataBuffer(THIS);
   STDMETHODIMP ExtensionDataChanged(THIS);
   STDMETHODIMP HandleEvent(THIS_ ULONG sourceID);
   STDMETHODIMP_(short) GetResID(THIS);

   // I3DExShader methods
   STDMETHODIMP_(BOOLEAN) IsEqualTo(THIS_ I3DExShader* aShader);
   STDMETHODIMP_(BOOLEAN) DependsOnAppliedExtent(THIS);
   STDMETHODIMP GetShadingFlags(THIS_ ShadingFlags* theFlags);
   STDMETHODIMP_(ULONG) GetPreferredOutput(THIS);
   STDMETHODIMP DoShade(THIS_ ShadingInOut* theShadingIO, ShadingElem* theShadingElem);
   STDMETHODIMP GetValue(THIS_ NUM3D* result, ShadingIn* theShadingIn, ShadingElem* theShadingElem);
   STDMETHODIMP GetColor(THIS_ COLOR3D* result, ShadingIn* theShadingIn, ShadingElem* theShadingElem);
   STDMETHODIMP GetVector(THIS_ VECTOR3D* result, ShadingIn* theShadingIn, ShadingElem* theShadingElem);


   EDPValShaderPublicData shaderPublicData;
  
 protected:
   int refCount;
};

#endif
